require 'socket'
require 'timeout'

port = if ARGV[0] then ARGV[0] else 'echo' end
sock = UDPSocket.open

sock.setsockopt(Socket::SOL_SOCKET, 
                Socket::SO_BROADCAST, true)
begin
  sock.send('message', 0, '<broadcast>', port)
  timeout(5) {
    loop do
      msg, addr = sock.recvfrom(20)
      p addr
    end
  }
rescue TimeoutError
end
sock.close
